

#if !defined __VGEV_ICON_H
#define __VGEV_ICON_H

#include "vgev_draw.h"


/* **************************************************************
************************************************************** */
class icon_type : public dbl_llist {

   protected:
      dbl_llist_manager drawman;

   public:
      int type;

      virtual ~icon_type() {}

      void render(canvas *tgev, unsigned char *color, int x, int y);
      void scan_data(sfile *sinfile, char *token);
};


/* **************************************************************
************************************************************** */
class vector_base_type : public dbl_llist {

   public:
      virtual ~vector_base_type() {}
      virtual void scan_data(sfile *sinfile, char *token) = 0;
      virtual void render(int x, int y) = 0;
};


/* **************************************************************
************************************************************** */
class vector_point_type : public vector_base_type {

   protected:
      vector2d *pt;
      int count;

   public:
      void scan_data(sfile *sinfile, char *token);
      void render(int x, int y);

      vector_point_type();
      virtual ~vector_point_type();
};

      
/* **************************************************************
************************************************************** */
class vector_arc_type : public vector_base_type {

   protected:
      vector2d pt[32];

   public:
      void scan_data(sfile *sinfile, char *token);
      void render(int x, int y);

      int fill_flag;

      vector_arc_type();
      virtual ~vector_arc_type() {}
};

      
/* **************************************************************
************************************************************** */
class vector_polygon_type : public vector_base_type {

   protected:
      vector2d *pt;
      int count;

   public:
      void scan_data(sfile *sinfile, char *token);
      void render(int x, int y);

      int fill_flag;

      vector_polygon_type();
      virtual ~vector_polygon_type();
};

      
/* **************************************************************
************************************************************** */
class vector_line_type : public vector_base_type {

   protected:
      vector4d *pt;
      int count;

   public:
      void scan_data(sfile *sinfile, char *token);
      void render(int x, int y);

      vector_line_type();
      virtual ~vector_line_type();
};


/* **************************************************************
************************************************************** */
class icon_manager_type : public dbl_llist_manager {

    public:
       virtual ~icon_manager_type() {}
       int read_data(char *filename);
};

#endif

extern icon_manager_type iconman;
