

#include "vsds.h"


spost_office_type pcigiface;


/* ***************************************************************************
*************************************************************************** */
void sds_iface::parse_input(int argc, char **argv) {

   iface::parse_input(argc, argv);   
}


/* ============================================================================
 ============================================================================ */
void sds_iface::update(double *machine_time) {

   int status = 0;      // not paused
   double multiple = 1; // realtime
   basic_platform *ptr;

   for (ptr=(basic_platform *)head; ptr; ptr=(basic_platform *)ptr->next)
      ptr->update(this, machine_time, &multiple, machine_time, status);

   burn_driftwood();
}


/* ============================================================================
 ============================================================================ */
basic_platform *sds_iface::add_platform(int id, int type) {

   sds_platform *p;

   insert(p = new sds_platform, NULL);

   p->id = id;
   p->type = type;

   p->init(this);

   return p;
}


/* ============================================================================
 ============================================================================ */
void sds_iface::burn_driftwood() {

   basic_platform *ptr;
   
   for (ptr = (basic_platform *)head; ptr; ptr = (basic_platform *)ptr->next)
      if (!(ptr->platform_flag & PLATFORM_FLAG_POSTMORTIUM) &&
          (ptr->platform_flag & PLATFORM_FLAG_DEAD)) {
         ptr->platform_flag |= PLATFORM_FLAG_DEAD | PLATFORM_FLAG_POSTMORTIUM;
         ptr->perform(this, PERFORM_PLATFORM_DEACTIVATE, NULL);
      }
   
}

