

#include "dataio.h"

#include "vsds.h"


/* ============================================================================
   adjust camera so that its 2 units above terrain at least
============================================================================ */
int sdscam_ai::clamp_tunneling(double *x, double *y, double *z) {

   static int counter = 1;

   buffer_type buffer;
   sfile sbuffer;

   sbuffer.dest();
   sbuffer.sput_int(PCIG_TYPE_TERRAIN_HEIGHT);
   sbuffer.sput_int(PCIG_SIZE_TERRAIN_HEIGHT);
   sbuffer.sput_int(counter++);
   sbuffer.sput_int(0);
   sbuffer.sput_double(*x);
   sbuffer.sput_double(0);
   sbuffer.sput_double(-*y);

   buffer.buffercpy((char *)sbuffer.data, sbuffer.vsize);
   pcigiface.send_message(&buffer);

   while (!pcigiface.find_message(PCIG_TYPE_TERRAIN_HEIGHT_RESPONSE, &buffer));

   sbuffer.scan_data(&buffer);

   sbuffer.scan_int();
   sbuffer.scan_int();
   sbuffer.scan_int();

   *z = sbuffer.scan_float() + 2;

   return 1;
}


/* ============================================================================
   adjust camera so that its 2 units above terrain at least
============================================================================ */
int sdscam_ai::nix_tunneling(double *x, double *y, double *z) {

   double tz;

   tz = *z;

   if (clamp(x, y, &tz) &&((attach_object && !(attach_object->platform_flag & PLATFORM_FLAG_FLY)) || *z < tz)) {
      *z = tz;
      return 1;
   }

   return 0;
}


/* ============================================================================
============================================================================ */
void sdscam_ai::animate_camera(iface *iman, user_io *userinput, timer_type *timer) {

   sfile sbuffer;
   buffer_type buffer;
   
   camera_ai::animate_camera(iman, userinput, timer);

   sbuffer.dest();

   sbuffer.sput_int(PCIG_TYPE_VIEWPOINT);
   sbuffer.sput_int(PCIG_SIZE_VIEWPOINT);
   sbuffer.sput_int(PCIG_VIEWPOINT_ALL);
   sbuffer.sput_int(0); // clamp flag 0=off

   sbuffer.sput_double(xyz[0]);
   sbuffer.sput_double(xyz[2]);
   sbuffer.sput_double(-xyz[1]);

   sbuffer.sput_float((float)rpy[1]);
   sbuffer.sput_float((float)rpy[2]);
   sbuffer.sput_float((float)-rpy[0]);

   sbuffer.sput_int(0);

   buffer.buffercpy((char *)sbuffer.data, sbuffer.vsize);
   pcigiface.send_message(&buffer);
}

