

#include "global.h"
#include "pstring.h"

#include "vissim.h"


/* ****************************************************************************
**************************************************************************** */
platform_data *default_loader(basic_platform *parent) {

   return NULL;
}


/* ***************************************************************************
*************************************************************************** */
iface::iface() {

   interface_flag = INTERFACE_FLAG_NULL;
   data_loader = (void *)default_loader;
}


/* ***************************************************************************
*************************************************************************** */
void iface::label(dbl_llist_manager *label_manager) {

   basic_platform *ptr;

   for (ptr=(basic_platform *)head; ptr; ptr=(basic_platform *)ptr->next)
      ptr->label(label_manager);
}


/* ***************************************************************************
*************************************************************************** */
void iface::parse_input(int argc, char **argv) {

}


/* ***************************************************************************
*************************************************************************** */
void iface::init() {

   string_type buffer;

   dest();

   platman.dest();

   if (!platman.read_data(DATANAME_SEMOBJ.string)) {
      buffer.stringcpy("Cannot read/parse \"");
      buffer.stringcat(&DATANAME_SEMOBJ);
      buffer.stringcat("\"... Aborting\n");
      pprintf(buffer.string);
      exit(-1);
   }

   init_earth(0, 0, (float)EARTH_RADIUS);
}


/* ****************************************************************************
**************************************************************************** */
void iface::mcp(plat_stat_type *pc) {

}


/* ****************************************************************************
**************************************************************************** */
basic_platform *iface::get_platform(int platid) {

   basic_platform *ptr;
   
   for (ptr = (basic_platform *)head; ptr; ptr = (basic_platform *)ptr->next)
      if (ptr->id == platid)
         break;

   return ptr; 
}


/* ****************************************************************************
**************************************************************************** */
void iface::register_platform_data_loaderCB(void *func) {

   data_loader = func;
}


